MIPBase< Data_T > Class Template Referenceabstract

`#include <MIPBase.h>`

Inheritance diagram for MIPBase< Data_T >:

## Public Types

typedef MIPBase< Data_T > | class_type
typedef boost::intrusive_ptr< MIPBase > | Ptr
Public Types inherited from Field< Data_T >
typedef Field< Data_T > | class_type
typedef boost::intrusive_ptr< Field > | Ptr
typedef Data_T | value_type
| Allows us to reference the template class.
typedef std::vector< Ptr > | Vec
| This is a convenience typedef for the list that Field3DInputFile::readScalarLayers() and Field3DInputFile::readVectorLayers() will return its data in.
Public Types inherited from FieldRes
typedef FieldRes | class_type
typedef boost::intrusive_ptr< FieldRes > | Ptr
typedef std::vector< Ptr > | Vec
Public Types inherited from FieldBase
typedef FieldBase | class_type
typedef boost::intrusive_ptr< FieldBase > | Ptr
Public Types inherited from RefBase
typedef boost::intrusive_ptr< RefBase > | Ptr
typedef boost::weak_ptr< RefBase > | WeakPtr

## Public Member Functions

virtual void | getVsMIPCoord (const V3f &vsP, const size_t level, V3f &outVsP) const =0
| Given a voxel space coordinate in the 0-level field, computes the coordinate in another level.
virtual bool | levelLoaded (const size_t level) const =0
| Whether a given MIP level is loaded.
size_t | lowestLevel () const
| Lowest MIP level to use.
| MIPBase ()
virtual Field< Data_T >::Ptr | mipLevel (const size_t level) const =0
| Returns a MIP level field.
const V3i & | mipOffset () const
| Returns the base MIP offset.
virtual V3i | mipResolution (size_t level) const =0
| Returns the resolution of a given MIP level.
virtual Data_T | mipValue (size_t level, int i, int j, int k) const =0
| Read access to a voxel in a given MIP level.
size_t | numLevels () const
| Number of MIP levels.
void | setLowestLevel (size_t level)
| Sets the lowest MIP level to use. Defaults to zero, but can be set higher to prevent high resolution levels from being accessed.
void | setMIPOffset (const V3i &offset)
| Sets the base MIP offset. This is used to indicate where voxel space coordinate (0, 0, 0) really maps to.
Public Member Functions inherited from Field< Data_T >
const_iterator | cbegin () const
| Const iterator to first element. "cbegin" matches the tr1 c++ standard.
const_iterator | cbegin (const Box3i &subset) const
| Const iterator to first element of specific subset.
const_iterator | cend () const
| Const iterator pointing one element past the last valid one.
const_iterator | cend (const Box3i &subset) const
| Const iterator pointing one element past the last valid one (for a subset).
virtual std::string | dataTypeString () const
virtual Data_T | value (int i, int j, int k) const =0
| Read access to a voxel. The coordinates are in integer voxel space .
virtual | ~Field ()
| Dtor.
Public Member Functions inherited from FieldRes
V3i const | dataResolution () const
const Box3i & | dataWindow () const
| Returns the data window. Any coordinate inside this window is safe to pass to value() in the Field subclass.
const Box3i & | extents () const
| Returns the extents of the data. This signifies the relevant area that the data exists over. However, the data window (below) may be smaller than the extents, in which case it is only safe to call value() for those coordinate inside the data window.
| FieldRes ()
| This constructor ensures that we have a valid mapping at all times.
| FieldRes (const FieldRes &src)
| Base class copy constructor.
bool | isInBounds (int i, int j, int k) const
| Returns true is the indicies are in bounds of the data window.
FieldMapping::Ptr | mapping ()
| Returns a pointer to the mapping.
const FieldMapping::Ptr | mapping () const
| Returns a pointer to the mapping.
virtual void | mappingChanged ()
| Tells the subclass that the mapping changed.
virtual long long int | memSize () const
| Returns the memory usage (in bytes).
void | setMapping (FieldMapping::Ptr mapping)
| Sets the field's mapping.
virtual size_t | voxelCount () const
| Counts the number of voxels. For most fields, this is just the volume of the data window, but sparse data structures can override this to return a better value.
Public Member Functions inherited from FieldBase
| FieldBase ()
| Constructor.
| FieldBase (const FieldBase &)
| Copy Constructor.
virtual | ~FieldBase ()
| Destructor.
virtual std::string | className () const =0
| Returns the class name of the object. Used by the class pool and when writing the data to disk.
virtual std::string | classType () const =0
| Returns the full class type string.
virtual Ptr | clone () const =0
| Returns a pointer to a copy of the field, pure virtual so ensure derived classes properly implement it.
FieldMetadata & | metadata ()
| accessor to the m_metadata class
const FieldMetadata & | metadata () const
| Read only access to the m_metadata class.
void | copyMetadata (const FieldBase &field)
| Copies the metadata from a second field.
Public Member Functions inherited from RefBase
void | ref () const
| Used by boost::intrusive_pointer.
size_t | refcnt ()
| Used by boost::intrusive_pointer.
void | unref () const
| Used by boost::intrusive_pointer.
WeakPtr | weakPtr () const
| RefBase ()
| RefBase (const RefBase &)
| Copy constructor.
RefBase & | operator= (const RefBase &)
| Assignment operator.
virtual | ~RefBase ()
| Destructor.
virtual bool | checkRTTI (const char *typenameStr)=0
| This function is only implemented by concrete classes and triggers the actual RTTI check through matchRTTI();.
bool | matchRTTI (const char *typenameStr)
| Performs a check to see if the given typename string matches this class' This needs to be implemented in -all- subclasses, even abstract ones.
Public Member Functions inherited from MetadataCallback
virtual void | metadataHasChanged (const std::string &)
| Alerts the callback holder that the metadata has changed.

## Static Public Member Functions

static const char * | staticClassName ()
static const char * | staticClassType ()
Static Public Member Functions inherited from Field< Data_T >
static const char * | staticClassName ()
static const char * | staticClassType ()
Static Public Member Functions inherited from FieldRes
static const char * | staticClassName ()
static const char * | staticClassType ()
Static Public Member Functions inherited from FieldBase
static const char * | staticClassName ()
static const char * | staticClassType ()
static const char * | staticClassType ()

## Public Attributes

| DEFINE_FIELD_RTTI_ABSTRACT_CLASS
Public Attributes inherited from Field< Data_T >
| DEFINE_FIELD_RTTI_ABSTRACT_CLASS
Public Attributes inherited from FieldRes
| DEFINE_FIELD_RTTI_ABSTRACT_CLASS
Public Attributes inherited from FieldBase
std::string | attribute
| Optional name of the attribute the field represents.
std::string | name
| Optional name of the field.

## Protected Types

typedef Field< Data_T > | base
Protected Types inherited from FieldRes
typedef MatrixFieldMapping | default_mapping

## Protected Attributes

size_t | m_lowestLevel
| The lowest MIP level to use. Defaults to 0, but can be set higher to prevent high resolution levels from being accessed.
V3i | m_mipOffset
| Base coordinate offset. This is used to indicate where voxel space coordinate (0, 0, 0) really maps to.
size_t | m_numLevels
| Number of MIP levels. The default is 1.
Protected Attributes inherited from FieldRes
Box3i | m_dataWindow
| Defines the area where data is allocated. This should be treated as a closed (i.e. inclusive) interval.
Box3i | m_extents
| Defines the extents of the the storage. This may be larger or smaller than the data window, and in the case where it is larger, care must be taken not to access voxels outside the data window. This should be treated as a closed (i.e. inclusive) interval.
FieldMapping::Ptr | m_mapping
| Pointer to the field's mapping.

## Static Protected Attributes

static TemplatedFieldType< MIPBase< Data_T > > | ms_classType

## Detailed Description

template<class Data_T>
class MIPBase< Data_T >

Some assumptions:

MIP fields are neither Resizable nor Writable. They are constructed from an existing field such as DenseField, SparseField, etc.

The highest resolution representation is level 0.

All MIPBase subclasses are delayed-read, so as not to touch high res data unless needed.

The base class provides mipValue() and mipLValue(). It is assumed that concrete subclasses provide fastMipValue() and fastMipLValue().

Definition at line 116 of file MIPBase.h.

## Member Typedef Documentation

## Ptr

template<class Data_T>

typedef boost::intrusive_ptr<MIPBase> MIPBase< Data_T >::Ptr

Definition at line 123 of file MIPBase.h.

## class_type

template<class Data_T>

typedef MIPBase<Data_T> MIPBase< Data_T >::class_type

Definition at line 127 of file MIPBase.h.

## base

template<class Data_T>

typedef Field<Data_T> MIPBase< Data_T >::base

protected

Definition at line 191 of file MIPBase.h.

## Constructor & Destructor Documentation

## MIPBase()

template<typename Data_T>

MIPBase< Data_T >::MIPBase | ( |  | ) |

Definition at line 213 of file MIPBase.h.

: m_numLevels(1), m_lowestLevel(0), m_mipOffset(0)
{
}
MIPBase::m_mipOffset
V3i m_mipOffset
Base coordinate offset. This is used to indicate where voxel space coordinate (0, 0,...
Definition MIPBase.h:204
MIPBase::m_lowestLevel
size_t m_lowestLevel
The lowest MIP level to use. Defaults to 0, but can be set higher to prevent high resolution levels f...
Definition MIPBase.h:199
MIPBase::m_numLevels
size_t m_numLevels
Number of MIP levels. The default is 1.
Definition MIPBase.h:196

References m_lowestLevel, m_mipOffset, and m_numLevels.

## Member Function Documentation

## staticClassName()

template<class Data_T>

const char * MIPBase< Data_T >::staticClassName | ( |  | ) |

inline static

Definition at line 130 of file MIPBase.h.

{
return "MIPBase";
}

## staticClassType()

template<class Data_T>

const char * MIPBase< Data_T >::staticClassType | ( |  | ) |

inline static

Definition at line 135 of file MIPBase.h.

{
return MIPBase<Data_T>::ms_classType.name();
}
FieldBase::name
std::string name
Optional name of the field.
Definition Field.h:171
MIPBase
Definition MIPBase.h:117

References ms_classType.

## mipValue()

template<class Data_T>

virtual Data_T MIPBase< Data_T >::mipValue | ( | size_t | level,
|  | int | i,
|  | int | j,
|  | int | k ) const

pure virtual

Read access to a voxel in a given MIP level.

Parameters

  level | The MIP level to read from

Implemented in MIPField< Field_T >, MIPField< DenseField< Data_T > >, and MIPField< SparseField< Data_T > >.

## mipResolution()

template<class Data_T>

virtual V3i MIPBase< Data_T >::mipResolution | ( | size_t | level | ) | const

pure virtual

Returns the resolution of a given MIP level.

Implemented in MIPField< Field_T >, MIPField< DenseField< Data_T > >, and MIPField< SparseField< Data_T > >.

## levelLoaded()

template<class Data_T>

virtual bool MIPBase< Data_T >::levelLoaded | ( | const size_t | level | ) | const

pure virtual

Whether a given MIP level is loaded.

Implemented in MIPField< Field_T >, MIPField< DenseField< Data_T > >, and MIPField< SparseField< Data_T > >.

## getVsMIPCoord()

template<class Data_T>

virtual void MIPBase< Data_T >::getVsMIPCoord | ( | const V3f & | vsP,
|  | const size_t | level,
|  | V3f & | outVsP ) const

pure virtual

Given a voxel space coordinate in the 0-level field, computes the coordinate in another level.

Implemented in MIPField< Field_T >, MIPField< DenseField< Data_T > >, and MIPField< SparseField< Data_T > >.

## mipLevel()

template<class Data_T>

virtual Field< Data_T >::Ptr MIPBase< Data_T >::mipLevel | ( | const size_t | level | ) | const

pure virtual

Returns a MIP level field.

Implemented in MIPField< Field_T >, MIPField< DenseField< Data_T > >, and MIPField< SparseField< Data_T > >.

## setLowestLevel()

template<typename Data_T>

void MIPBase< Data_T >::setLowestLevel | ( | size_t | level | ) |

Sets the lowest MIP level to use. Defaults to zero, but can be set higher to prevent high resolution levels from being accessed.

Definition at line 222 of file MIPBase.h.

{
m_lowestLevel = level;
}

References m_lowestLevel.

## lowestLevel()

template<class Data_T>

size_t MIPBase< Data_T >::lowestLevel | ( |  | ) | const

inline

Lowest MIP level to use.

Definition at line 171 of file MIPBase.h.

{ return m_lowestLevel; }

References m_lowestLevel.

## numLevels()

template<class Data_T>

size_t MIPBase< Data_T >::numLevels | ( |  | ) | const

inline

Number of MIP levels.

Definition at line 174 of file MIPBase.h.

{ return m_numLevels; }

References m_numLevels.

## setMIPOffset()

template<typename Data_T>

void MIPBase< Data_T >::setMIPOffset | ( | const V3i & | offset | ) |

Sets the base MIP offset. This is used to indicate where voxel space coordinate (0, 0, 0) really maps to.

Definition at line 230 of file MIPBase.h.

{
this->metadata().setVecIntMetadata(detail::k_mipOffsetStr, offset);
m_mipOffset = offset;
}
FieldBase::metadata
FieldMetadata & metadata()
accessor to the m_metadata class
Definition Field.h:155
FieldMetadata::setVecIntMetadata
void setVecIntMetadata(const std::string &name, const V3i &val)
Set the a V3i value for the given metadata name.
Definition FieldMetadata.cpp:80

References detail::k_mipOffsetStr, m_mipOffset, and FieldBase::metadata().

Referenced by MIPField< Field_T >::mappingChanged().

## mipOffset()

template<class Data_T>

const V3i & MIPBase< Data_T >::mipOffset | ( |  | ) | const

inline

Returns the base MIP offset.

Definition at line 180 of file MIPBase.h.

{ return m_mipOffset; }

References m_mipOffset.

Referenced by MIPField< Field_T >::getVsMIPCoord().

## Member Data Documentation

## DEFINE_FIELD_RTTI_ABSTRACT_CLASS

template<class Data_T>

MIPBase< Data_T >::DEFINE_FIELD_RTTI_ABSTRACT_CLASS

Definition at line 128 of file MIPBase.h.

## ms_classType

template<class Data_T>

TemplatedFieldType<MIPBase<Data_T> > MIPBase< Data_T >::ms_classType

static protected

Definition at line 187 of file MIPBase.h.

Referenced by staticClassType().

## m_numLevels

template<class Data_T>

size_t MIPBase< Data_T >::m_numLevels

protected

Number of MIP levels. The default is 1.

Definition at line 196 of file MIPBase.h.

Referenced by MIPField< Field_T >::clear(), MIPField< Field_T >::concreteMipLevel(), MIPField< Field_T >::fastMipValue(), MIPField< Field_T >::levelLoaded(), MIPBase(), MIPField< Field_T >::MIPField(), MIPField< Field_T >::mipLevel(), MIPField< Field_T >::mipResolution(), numLevels(), MIPField< Field_T >::rawMipLevel(), MIPField< Field_T >::setup(), and MIPField< Field_T >::setupLazyLoad().

## m_lowestLevel

template<class Data_T>

size_t MIPBase< Data_T >::m_lowestLevel

protected

The lowest MIP level to use. Defaults to 0, but can be set higher to prevent high resolution levels from being accessed.

Definition at line 199 of file MIPBase.h.

Referenced by MIPField< Field_T >::clear(), lowestLevel(), MIPBase(), setLowestLevel(), MIPField< Field_T >::setup(), and MIPField< Field_T >::setupLazyLoad().

## m_mipOffset

template<class Data_T>

V3i MIPBase< Data_T >::m_mipOffset

protected

Base coordinate offset. This is used to indicate where voxel space coordinate (0, 0, 0) really maps to.

Note
  This is stored on disk in metadata, and is updated by the standard I/O routines.

Definition at line 204 of file MIPBase.h.

Referenced by MIPBase(), mipOffset(), and setMIPOffset().

The documentation for this class was generated from the following file:

- export/MIPBase.h